#!/usr/bin/perl -W

use strict;
use fasta;


print "####################\n";
print "###PROGRAM SANSME###\n";
print "####################\n\n";

foreach my $filename (@ARGV)
{
	(my $genome) =($filename=~/(\w*)_/);
	my $genome1sansME_file = $genome.".sansME";
	#Remove annotated files such as mobile elements from the analysis
	createGeneFile($filename, $genome1sansME_file,$genome);
}

print "###PROGRAM DONE###\n\n";

exit;

#Function that permit to remove repeats according to their annotation (phage, transposase or reverse transcriptase)
#Input:       	- file name to read
#               - file name to write
#This function need "fasta.pm" to work correctly.

sub createGeneFile 
{
        my ($filename0, $filename1, $name) = @_;

        my %genome1=();
        my $key='';
        my $value = '';

        %genome1 = extractSequenceFasta(getFileData($filename0));

        open(GENEFILE,">$filename1") or die "Cannot open file $filename1.";


my $compteur = 0;
my $compteur2=0;
        ($key,$value) = each %genome1;
        do
        {
		$compteur++;
                $_=$key;
		$key =~ tr/\(\)\[\]/----/;
		$key =~ s/\#//g;
		$key =~ s/\s/_/g;
                if (!(/phage/i || /transposase/i || /reverse transcriptase/i))
                {
			$compteur2++;
                     		print GENEFILE ">$key\n";
	                       	for (my $pos = 0; $pos <length($value);$pos+=60)
       	                	{
               	                	print GENEFILE substr ($value, $pos, 60), "\n";
                       		}

                }
        }while(($key,$value) = each %genome1);

close(GENEFILE);
my $difference = $compteur-$compteur2;
print "There are $compteur tested genes, $difference are annotated phage, transposase or reverse transcriptase, $compteur2 have passed the filter.\n";
}

